"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.raceInit = exports.race = void 0;
const Observable_1 = require("../Observable");
const from_1 = require("./from");
const argsOrArgArray_1 = require("../util/argsOrArgArray");
const Subscriber_1 = require("../Subscriber");
function race(...sources) {
    sources = (0, argsOrArgArray_1.argsOrArgArray)(sources);
    return sources.length === 1 ? (0, from_1.from)(sources[0]) : new Observable_1.Observable(raceInit(sources));
}
exports.race = race;
function raceInit(sources) {
    return (destination) => {
        let subscriptions = [];
        for (let i = 0; subscriptions && !destination.closed && i < sources.length; i++) {
            subscriptions.push((0, from_1.from)(sources[i]).subscribe((0, Subscriber_1.operate)({
                destination,
                next: (value) => {
                    if (subscriptions) {
                        for (let s = 0; s < subscriptions.length; s++) {
                            s !== i && subscriptions[s].unsubscribe();
                        }
                        subscriptions = null;
                    }
                    destination.next(value);
                },
            })));
        }
    };
}
exports.raceInit = raceInit;
//# sourceMappingURL=race.js.map