"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buffer = void 0;
const Observable_1 = require("../Observable");
const noop_1 = require("../util/noop");
const Subscriber_1 = require("../Subscriber");
const from_1 = require("../observable/from");
function buffer(closingNotifier) {
    return (source) => new Observable_1.Observable((destination) => {
        let currentBuffer = [];
        (0, from_1.from)(closingNotifier).subscribe((0, Subscriber_1.operate)({
            destination,
            next: () => {
                const b = currentBuffer;
                currentBuffer = [];
                destination.next(b);
            },
            complete: noop_1.noop,
        }));
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => currentBuffer.push(value),
            complete: () => {
                destination.next(currentBuffer);
                destination.complete();
            },
        }));
        return () => {
            currentBuffer = null;
        };
    });
}
exports.buffer = buffer;
//# sourceMappingURL=buffer.js.map