"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.connect = void 0;
const Observable_1 = require("../Observable");
const Subject_1 = require("../Subject");
const from_1 = require("../observable/from");
const fromSubscribable_1 = require("../observable/fromSubscribable");
const DEFAULT_CONFIG = {
    connector: () => new Subject_1.Subject(),
};
function connect(selector, config = DEFAULT_CONFIG) {
    const { connector } = config;
    return (source) => new Observable_1.Observable((subscriber) => {
        const subject = connector();
        (0, from_1.from)(selector((0, fromSubscribable_1.fromSubscribable)(subject))).subscribe(subscriber);
        subscriber.add(source.subscribe(subject));
    });
}
exports.connect = connect;
//# sourceMappingURL=connect.js.map