"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultIfEmpty = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function defaultIfEmpty(defaultValue) {
    return (source) => new Observable_1.Observable((destination) => {
        let hasValue = false;
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => {
                hasValue = true;
                destination.next(value);
            },
            complete: () => {
                if (!hasValue) {
                    destination.next(defaultValue);
                }
                destination.complete();
            },
        }));
    });
}
exports.defaultIfEmpty = defaultIfEmpty;
//# sourceMappingURL=defaultIfEmpty.js.map