"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.endWith = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
const from_1 = require("../observable/from");
function endWith(...values) {
    return (source) => new Observable_1.Observable((destination) => {
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            complete: () => {
                (0, from_1.subscribeToArray)(values, destination);
            },
        }));
    });
}
exports.endWith = endWith;
//# sourceMappingURL=endWith.js.map