"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.every = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function every(predicate, thisArg) {
    return (source) => new Observable_1.Observable((destination) => {
        let index = 0;
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => {
                if (!predicate.call(thisArg, value, index++, source)) {
                    destination.next(false);
                    destination.complete();
                }
            },
            complete: () => {
                destination.next(true);
                destination.complete();
            },
        }));
    });
}
exports.every = every;
//# sourceMappingURL=every.js.map