"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exhaustMap = void 0;
const Subscriber_1 = require("../Subscriber");
const from_1 = require("../observable/from");
const Observable_1 = require("../Observable");
function exhaustMap(project) {
    return (source) => new Observable_1.Observable((destination) => {
        let index = 0;
        let innerSub = null;
        let isComplete = false;
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (outerValue) => {
                if (!innerSub) {
                    innerSub = (0, Subscriber_1.operate)({
                        destination,
                        complete: () => {
                            innerSub = null;
                            isComplete && destination.complete();
                        },
                    });
                    (0, from_1.from)(project(outerValue, index++)).subscribe(innerSub);
                }
            },
            complete: () => {
                isComplete = true;
                !innerSub && destination.complete();
            },
        }));
    });
}
exports.exhaustMap = exhaustMap;
//# sourceMappingURL=exhaustMap.js.map