"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filter = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function filter(predicate, thisArg) {
    return (source) => new Observable_1.Observable((destination) => {
        let index = 0;
        source.subscribe((0, Subscriber_1.operate)({ destination, next: (value) => predicate.call(thisArg, value, index++) && destination.next(value) }));
    });
}
exports.filter = filter;
//# sourceMappingURL=filter.js.map