"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.materialize = void 0;
const NotificationFactories_1 = require("../NotificationFactories");
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function materialize() {
    return (source) => new Observable_1.Observable((destination) => {
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => {
                destination.next((0, NotificationFactories_1.nextNotification)(value));
            },
            error: (error) => {
                destination.next((0, NotificationFactories_1.errorNotification)(error));
                destination.complete();
            },
            complete: () => {
                destination.next(NotificationFactories_1.COMPLETE_NOTIFICATION);
                destination.complete();
            },
        }));
    });
}
exports.materialize = materialize;
//# sourceMappingURL=materialize.js.map