"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.observeOn = void 0;
const executeSchedule_1 = require("../util/executeSchedule");
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function observeOn(scheduler, delay = 0) {
    return (source) => new Observable_1.Observable((destination) => {
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => (0, executeSchedule_1.executeSchedule)(destination, scheduler, () => destination.next(value), delay),
            error: (err) => (0, executeSchedule_1.executeSchedule)(destination, scheduler, () => destination.error(err), delay),
            complete: () => (0, executeSchedule_1.executeSchedule)(destination, scheduler, () => destination.complete(), delay),
        }));
    });
}
exports.observeOn = observeOn;
//# sourceMappingURL=observeOn.js.map