"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sample = void 0;
const from_1 = require("../observable/from");
const Observable_1 = require("../Observable");
const noop_1 = require("../util/noop");
const Subscriber_1 = require("../Subscriber");
function sample(notifier) {
    return (source) => new Observable_1.Observable((destination) => {
        let hasValue = false;
        let lastValue = null;
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => {
                hasValue = true;
                lastValue = value;
            },
        }));
        (0, from_1.from)(notifier).subscribe((0, Subscriber_1.operate)({
            destination,
            next: () => {
                if (hasValue) {
                    hasValue = false;
                    const value = lastValue;
                    lastValue = null;
                    destination.next(value);
                }
            },
            complete: noop_1.noop,
        }));
    });
}
exports.sample = sample;
//# sourceMappingURL=sample.js.map