"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipUntil = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
const from_1 = require("../observable/from");
const noop_1 = require("../util/noop");
function skipUntil(notifier) {
    return (source) => new Observable_1.Observable((destination) => {
        let taking = false;
        const skipSubscriber = (0, Subscriber_1.operate)({
            destination,
            next: () => {
                skipSubscriber?.unsubscribe();
                taking = true;
            },
            complete: noop_1.noop,
        });
        (0, from_1.from)(notifier).subscribe(skipSubscriber);
        source.subscribe((0, Subscriber_1.operate)({ destination, next: (value) => taking && destination.next(value) }));
    });
}
exports.skipUntil = skipUntil;
//# sourceMappingURL=skipUntil.js.map