"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipWhile = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function skipWhile(predicate) {
    return (source) => new Observable_1.Observable((destination) => {
        let taking = false;
        let index = 0;
        source.subscribe((0, Subscriber_1.operate)({ destination, next: (value) => (taking || (taking = !predicate(value, index++))) && destination.next(value) }));
    });
}
exports.skipWhile = skipWhile;
//# sourceMappingURL=skipWhile.js.map