"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.switchScan = void 0;
const switchMap_1 = require("./switchMap");
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function switchScan(accumulator, seed) {
    return (source) => new Observable_1.Observable((destination) => {
        let state = seed;
        (0, switchMap_1.switchMap)((value, index) => accumulator(state, value, index))(source).subscribe((0, Subscriber_1.operate)({
            destination,
            next: (innerValue) => {
                state = innerValue;
                destination.next(innerValue);
            },
        }));
        return () => {
            state = null;
        };
    });
}
exports.switchScan = switchScan;
//# sourceMappingURL=switchScan.js.map