"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.take = void 0;
const empty_1 = require("../observable/empty");
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function take(count) {
    return count <= 0
        ?
            () => empty_1.EMPTY
        : (source) => new Observable_1.Observable((destination) => {
            let seen = 0;
            const operatorSubscriber = (0, Subscriber_1.operate)({
                destination,
                next: (value) => {
                    if (++seen < count) {
                        destination.next(value);
                    }
                    else {
                        operatorSubscriber.unsubscribe();
                        destination.next(value);
                        destination.complete();
                    }
                },
            });
            source.subscribe(operatorSubscriber);
        });
}
exports.take = take;
//# sourceMappingURL=take.js.map