"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeUntil = void 0;
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
const from_1 = require("../observable/from");
const noop_1 = require("../util/noop");
function takeUntil(notifier) {
    return (source) => new Observable_1.Observable((destination) => {
        (0, from_1.from)(notifier).subscribe((0, Subscriber_1.operate)({ destination, next: () => destination.complete(), complete: noop_1.noop }));
        !destination.closed && source.subscribe(destination);
    });
}
exports.takeUntil = takeUntil;
//# sourceMappingURL=takeUntil.js.map