"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.throwIfEmpty = void 0;
const EmptyError_1 = require("../util/EmptyError");
const Observable_1 = require("../Observable");
const Subscriber_1 = require("../Subscriber");
function throwIfEmpty(errorFactory = defaultErrorFactory) {
    return (source) => new Observable_1.Observable((destination) => {
        let hasValue = false;
        source.subscribe((0, Subscriber_1.operate)({
            destination,
            next: (value) => {
                hasValue = true;
                destination.next(value);
            },
            complete: () => (hasValue ? destination.complete() : destination.error(errorFactory())),
        }));
    });
}
exports.throwIfEmpty = throwIfEmpty;
function defaultErrorFactory() {
    return new EmptyError_1.EmptyError();
}
//# sourceMappingURL=throwIfEmpty.js.map