"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HotObservable = void 0;
const Subject_1 = require("../Subject");
const Subscription_1 = require("../Subscription");
const Notification_1 = require("../Notification");
const subscription_logging_1 = require("./subscription-logging");
class HotObservable extends Subject_1.Subject {
    messages;
    scheduler;
    subscriptions = [];
    logSubscribedFrame = subscription_logging_1.logSubscribedFrame;
    logUnsubscribedFrame = subscription_logging_1.logUnsubscribedFrame;
    constructor(messages, scheduler) {
        super();
        this.messages = messages;
        this.scheduler = scheduler;
    }
    _subscribe(subscriber) {
        const index = this.logSubscribedFrame();
        const subscription = new Subscription_1.Subscription();
        subscription.add(new Subscription_1.Subscription(() => {
            this.logUnsubscribedFrame(index);
        }));
        subscription.add(super._subscribe(subscriber));
        return subscription;
    }
    setup() {
        for (const { notification, frame } of this.messages) {
            this.scheduler.schedule(() => {
                (0, Notification_1.observeNotification)(notification, this);
            }, frame);
        }
    }
}
exports.HotObservable = HotObservable;
//# sourceMappingURL=HotObservable.js.map