import { COMPLETE_NOTIFICATION, errorNotification, nextNotification } from '../NotificationFactories';
import { Observable } from '../Observable';
import { operate } from '../Subscriber';
export function materialize() {
    return (source) => new Observable((destination) => {
        source.subscribe(operate({
            destination,
            next: (value) => {
                destination.next(nextNotification(value));
            },
            error: (error) => {
                destination.next(errorNotification(error));
                destination.complete();
            },
            complete: () => {
                destination.next(COMPLETE_NOTIFICATION);
                destination.complete();
            },
        }));
    });
}
//# sourceMappingURL=materialize.js.map