import { Observable } from '../Observable';
import { from } from '../observable/from';
import { Subject } from '../Subject';
import { operate } from '../Subscriber';
export function retryWhen(notifier) {
    return (source) => new Observable((destination) => {
        let innerSub;
        let syncResub = false;
        let errors$;
        const subscribeForRetryWhen = () => {
            innerSub = source.subscribe(operate({
                destination,
                error: (err) => {
                    if (!errors$) {
                        errors$ = new Subject();
                        from(notifier(errors$)).subscribe(operate({
                            destination,
                            next: () => innerSub ? subscribeForRetryWhen() : (syncResub = true),
                        }));
                    }
                    if (errors$) {
                        errors$.next(err);
                    }
                },
            }));
            if (syncResub) {
                innerSub.unsubscribe();
                innerSub = null;
                syncResub = false;
                subscribeForRetryWhen();
            }
        };
        subscribeForRetryWhen();
    });
}
//# sourceMappingURL=retryWhen.js.map