import { isFunction } from './isFunction';
export async function* readableStreamLikeToAsyncGenerator(readableStream) {
    const reader = readableStream.getReader();
    try {
        while (true) {
            const { value, done } = await reader.read();
            if (done) {
                return;
            }
            yield value;
        }
    }
    finally {
        reader.releaseLock();
    }
}
export function isReadableStreamLike(obj) {
    return isFunction(obj?.getReader);
}
//# sourceMappingURL=isReadableStreamLike.js.map